[Debian-live-changes] r998 - in dists/trunk/live-helper: doc functions helpers manpages

Daniel Baumann daniel at alioth.debian.org
Mon Apr 9 17:54:43 UTC 2007


Author: daniel
Date: 2007-04-09 17:54:43 +0000 (Mon, 09 Apr 2007)
New Revision: 998

Added:
   dists/trunk/live-helper/helpers/lh_binary_yaboot
Modified:
   dists/trunk/live-helper/doc/ChangeLog
   dists/trunk/live-helper/functions/defaults.sh
   dists/trunk/live-helper/helpers/lh_binary
   dists/trunk/live-helper/manpages/lh_binary.1
   dists/trunk/live-helper/manpages/live-helper.7
Log:


Modified: dists/trunk/live-helper/doc/ChangeLog
===================================================================
--- dists/trunk/live-helper/doc/ChangeLog	2007-04-09 17:31:17 UTC (rev 997)
+++ dists/trunk/live-helper/doc/ChangeLog	2007-04-09 17:54:43 UTC (rev 998)
@@ -1,6 +1,6 @@
 2007-04-09  Daniel Baumann  <daniel at debian.org>
 
-	* templates/yaboot/yaboot.conf:
+	* helpers/lh_binary_yaboot, templates/yaboot/yaboot.conf:
 	  - Added.
 
 2007-04-09  Daniel Baumann  <daniel at debian.org>

Modified: dists/trunk/live-helper/functions/defaults.sh
===================================================================
--- dists/trunk/live-helper/functions/defaults.sh	2007-04-09 17:31:17 UTC (rev 997)
+++ dists/trunk/live-helper/functions/defaults.sh	2007-04-09 17:54:43 UTC (rev 998)
@@ -540,7 +540,15 @@
 	# Setting grub
 	if [ -z "${LIVE_BOOTLOADER}" ]
 	then
-		LIVE_BOOTLOADER="syslinux"
+		case "${LIVE_ARCHITECTURE}" in
+			i386)
+				LIVE_BOOTLOADER="syslinux"
+				;;
+
+			powerpc)
+				LIVE_BOOTLOADER="yaboot"
+				;;
+		esac
 	fi
 
 	# Setting grub splash

Modified: dists/trunk/live-helper/helpers/lh_binary
===================================================================
--- dists/trunk/live-helper/helpers/lh_binary	2007-04-09 17:31:17 UTC (rev 997)
+++ dists/trunk/live-helper/helpers/lh_binary	2007-04-09 17:54:43 UTC (rev 998)
@@ -45,6 +45,7 @@
 lh_binary_memtest86 "${@}"
 lh_binary_grub "${@}"
 lh_binary_syslinux "${@}"
+lh_binary_yaboot "${@}"
 lh_binary_includes "${@}"
 lh_binary_localincludes "${@}"
 lh_binary_md5sum "${@}"

Added: dists/trunk/live-helper/helpers/lh_binary_yaboot
===================================================================
--- dists/trunk/live-helper/helpers/lh_binary_yaboot	2007-04-09 17:31:17 UTC (rev 997)
+++ dists/trunk/live-helper/helpers/lh_binary_yaboot	2007-04-09 17:54:43 UTC (rev 998)
@@ -0,0 +1,215 @@
+#!/bin/sh
+
+# lh_binary_yaboot(1) - installs yaboot into binary
+# Copyright (C) 2006-2007 Daniel Baumann <daniel at debian.org>
+#
+# live-helper comes with ABSOLUTELY NO WARRANTY; for details see COPYING.
+# This is free software, and you are welcome to redistribute it
+# under certain conditions; see COPYING for details.
+
+set -e
+
+# Source common functions
+for FUNCTION in /usr/share/live-helper/functions/*.sh
+do
+	. ${FUNCTION}
+done
+
+# Set static variables
+DESCRIPTION="installs yaboot into binary"
+HELP=""
+USAGE="${PROGRAM} [--force]"
+
+Arguments "${@}"
+
+Echo_debug "Init ${PROGRAM}"
+
+# Reading configuration files
+Read_conffile config/bootstrap
+Read_conffile config/chroot
+Read_conffile config/common
+Read_conffile config/image
+Set_defaults
+
+Breakpoint "binary_yaboot: Init"
+
+# Requiring stage file
+Require_stagefile .stage/bootstrap
+
+# Checking lock file
+Check_lockfile .lock
+
+# Creating lock file
+Create_lockfile .lock
+
+# Checking stage file
+Check_stagefile .stage/binary_yaboot
+
+if [ "${LIVE_ARCHITECTURE}" != "powerpc" ] && [ "${LIVE_ARCHITECTURE}" != "ppc64" ]
+then
+	echo "W: skipping binary_yaboot, foreign architecture."
+	exit 0
+fi
+
+if [ "${LIVE_BOOTLOADER}" = "yaboot" ]
+then
+	# Check templates
+	if [ ! -d "${LIVE_TEMPLATES}" ]
+	then
+		if [ -d ../"${LIVE_TEMPLATES}" ]
+		then
+			LIVE_TEMPLATES="../${LIVE_TEMPLATES}"
+		else
+			Echo_error "user specified templates not accessible in ${LIVE_TEMPLATES}"
+			exit 1
+		fi
+	fi
+
+	if [ ! -f chroot/usr/lib/yaboot/yaboot ]
+	then
+		PACKAGES="${PACKAGES} yaboot"
+	fi
+
+	if [ -n "${PACKAGES}" ]
+	then
+		# Installing symlinks
+		case "${LH_APT}" in
+			apt|apt-get)
+				Chroot "apt-get install --yes ${PACKAGES}"
+				;;
+
+			aptitude)
+				Chroot "aptitude install --assume-yes ${PACKAGES}"
+				;;
+		esac
+	fi
+
+	# Setting destination directory
+	case "${LIVE_BINARY_IMAGE}" in
+		iso)
+			DESTDIR="binary/live"
+			;;
+
+		net|usb|hdd)
+			Echo_error "not supported, FIXME"
+			;;
+	esac
+
+	# Temporary check for broken yaboot
+	if [ "${LIVE_BINARY_IMAGE}" = "iso" ]
+	then
+		case "${LIVE_ARCHITECTURE}" in
+			powerpc)
+				DESTDIR="${DESTDIR}.ppc"
+				;;
+		esac
+	fi
+
+	# Creating directory
+	if [ ! -d "${DESTDIR}" ]
+	then
+		mkdir -p "${DESTDIR}"
+	fi
+
+	# Setting boot parameters
+	if [ -n "${LIVE_ENCRYPTION}" ]
+	then
+		LIVE_BOOTAPPEND="${LIVE_BOOTAPPEND} encryption=${LIVE_ENCRYPTION}"
+	fi
+
+	if [ -n "${LIVE_USERNAME}" ]
+	then
+		LIVE_BOOTAPPEND="${LIVE_BOOTAPPEND} username=${LIVE_USERNAME}"
+	fi
+
+	if [ -n "${LIVE_HOSTNAME}" ]
+	then
+		LIVE_BOOTAPPEND="${LIVE_BOOTAPPEND} hostname=${LIVE_HOSTNAME}"
+	fi
+
+	LIVE_BOOTAPPEND="`echo ${LIVE_BOOTAPPEND} | sed -e 's/  //'`"
+
+	# Assembling kernel configuration
+	if [ "${LIVE_BINARY_IMAGE}" = "iso" ]
+	then
+		DEFAULT_FLAVOUR="`echo ${LIVE_KERNEL_FLAVOUR} | awk '{ print $1 }'`"
+		LINUX="image=/`basename ${DESTDIR}`/`basename chroot/boot/vmlinuz-*${DEFAULT_FLAVOUR}`\n\tinitrd=/`basename ${DESTDIR}`/initrd.img-`basename chroot/boot/vmlinuz-*${DEFAULT_FLAVOUR} | sed -e 's/vmlinuz-//'`\n\tlabel=LIVE\n\tappend=\"boot=casper LIVE_BOOTAPPEND\"\n\tinitrd-size=1048576\n\tread-only"
+	else
+		DEFAULT_FLAVOUR="`echo ${LIVE_KERNEL_FLAVOUR} | awk '{ print $1 }'`"
+		LINUX="image=`basename chroot/boot/vmlinuz-*${DEFAULT_FLAVOUR}`\n\tinitrd=initrd.img-`basename chroot/boot/vmlinuz-*${DEFAULT_FLAVOUR} | sed -e 's/vmlinuz-//'`\n\tlabel=LIVE\n\tappend=\"boot=casper LIVE_BOOTAPPEND\"\n\tinitrd-size=1048576\n\tread-only"
+	fi
+
+	# FIXME
+	if [ "`echo ${LIVE_KERNEL_FLAVOUR} | wc -w`" -gt "1" ]
+	then
+		for KERNEL in chroot/boot/vmlinuz*
+		do
+			if [ -z "${LINUX}" ]
+			then
+				if [ "${LIVE_BINARY_IMAGE}" = "iso" ]
+				then
+					LINUX="label LIVE-`basename ${KERNEL} | sed -e 's/vmlinuz-//'`\n  kernel /`basename ${DESTDIR}`/`basename ${KERNEL}`\n  append initrd=/`basename ${DESTDIR}`/initrd.img-`basename ${KERNEL} | sed -e 's/vmlinuz-//'` boot=casper LIVE_BOOTAPPEND"
+				else
+					LINUX="label LIVE-`basename ${KERNEL} | sed -e 's/vmlinuz-//'`\n  kernel `basename ${KERNEL}`\n  append initrd=initrd.img-`basename ${KERNEL} | sed -e 's/vmlinuz-//'` boot=casper LIVE_BOOTAPPEND"
+				fi
+			else
+				if [ "${LIVE_BINARY_IMAGE}" = "iso" ]
+				then
+					LINUX="${LINUX}\nlabel LIVE-`basename ${KERNEL} | sed -e 's/vmlinuz-//'`\n  kernel /`basename ${DESTDIR}`/`basename ${KERNEL}`\n  append initrd=/`basename ${DESTDIR}`/initrd.img-`basename ${KERNEL} | sed -e 's/vmlinuz-//'` boot=casper LIVE_BOOTAPPEND"
+				else
+					LINUX="${LINUX}\nlabel LIVE-`basename ${KERNEL} | sed -e 's/vmlinuz-//'`\n  kernel `basename ${KERNEL}`\n  append initrd=initrd.img-`basename ${KERNEL} | sed -e 's/vmlinuz-//'` boot=casper LIVE_BOOTAPPEND"
+				fi
+			fi
+		done
+	fi
+
+	LINUX="`echo ${LINUX} | sed -e 's#//#/#g'`"
+
+	case "${LIVE_BINARY_IMAGE}" in
+		iso)
+			# Copying yaboot
+			mkdir -p binary/install
+			cp chroot/usr/lib/yaboot/yaboot binary/install
+			cp -r "${LIVE_TEMPLATES}"/yaboot/* binary/yaboot
+
+			# Configure yaboot templates
+			sed -i -e "s#LIVE_KERNEL_LIVE#${LINUX}#" -e "s#LIVE_KERNEL_INSTALL#${LIVE_KERNEL_INSTALL}#" -e "s#LIVE_MEMTEST#${MEMTEST}#" binary/install/yaboot.conf
+			sed -i -e "s#LIVE_BOOTAPPEND#${LIVE_BOOTAPPEND}#" binary/yaboot/yaboot.conf
+			sed -i -e "s/LIVE_DATE/`date +%Y%m%d`/" -e "s/LIVE_VERSION/${VERSION}/" binary/yaboot/boot.msg
+
+			# Working arround yaboot 8.3 limitation
+			if [ "`echo ${LIVE_KERNEL_FLAVOUR} | wc -w`" -gt "1" ]
+			then
+				for FLAVOUR in ${LIVE_KERNEL_FLAVOUR}
+				do
+					NUMBER=$(($NUMBER + 1))
+
+					mv "${DESTDIR}"/vmlinuz-*-${FLAVOUR} "${DESTDIR}"/vmlinuz${NUMBER}
+					mv "${DESTDIR}"/initrd.img-*-${FLAVOUR} "${DESTDIR}"/initrd${NUMBER}.img
+					sed -i -e "s/LIVE.*-${FLAVOUR}/live${NUMBER}/g" -e "s/vmlinuz-.*-${FLAVOUR}/vmlinuz${NUMBER}/g" -e "s/initrd.img-.*-${FLAVOUR}/initrd${NUMBER}.img/g" -e "s/LIVE/live/" binary/install/yaboot.conf
+				done
+			else
+				mv "${DESTDIR}"/vmlinuz-*-${LIVE_KERNEL_FLAVOUR} "${DESTDIR}"/vmlinuz
+				mv "${DESTDIR}"/initrd.img-*-${LIVE_KERNEL_FLAVOUR} "${DESTDIR}"/initrd.img
+				sed -i -e "s/LIVE.*-${LIVE_KERNEL_FLAVOUR}/live/g" -e "s/vmlinuz-.*-${LIVE_KERNEL_FLAVOUR}/vmlinuz/g" -e "s/initrd.img-.*-${LIVE_KERNEL_FLAVOUR}/initrd.img/g" -e "s/LIVE/live/" binary/install/yaboot.conf
+			fi
+			;;
+	esac
+
+	if [ -n "${PACKAGES}" ]
+	then
+		# Removing packages
+		case "${LH_APT}" in
+			apt|apt-get)
+				Chroot "apt-get remove --purge --yes ${PACKAGES}"
+				;;
+
+			aptitude)
+				Chroot "aptitude purge --assume-yes ${PACKAGES}"
+				;;
+		esac
+	fi
+
+	# Creating stage file
+	Create_stagefile .stage/binary_yaboot
+fi


Property changes on: dists/trunk/live-helper/helpers/lh_binary_yaboot
___________________________________________________________________
Name: svn:executable
   + *

Modified: dists/trunk/live-helper/manpages/lh_binary.1
===================================================================
--- dists/trunk/live-helper/manpages/lh_binary.1	2007-04-09 17:31:17 UTC (rev 997)
+++ dists/trunk/live-helper/manpages/lh_binary.1	2007-04-09 17:54:43 UTC (rev 998)
@@ -41,6 +41,8 @@
 copies syslinux into the binary image.
 .IP "\fIlh_binary_usb\fR(1)" 4
 creates the USB binary image.
+.IP "\fIlh_binary_yaboot\fR(1)" 4
+copies yaboot into the binary image.
 
 .SH SEE ALSO
 \fIlive\-helper\fR(7)

Modified: dists/trunk/live-helper/manpages/live-helper.7
===================================================================
--- dists/trunk/live-helper/manpages/live-helper.7	2007-04-09 17:31:17 UTC (rev 997)
+++ dists/trunk/live-helper/manpages/live-helper.7	2007-04-09 17:54:43 UTC (rev 998)
@@ -57,6 +57,8 @@
 copies syslinux into the binary image.
 .IP "\fIlh_binary_usb\fR(1)" 4
 creates the USB binary image.
+.IP "\fIlh_binary_yaboot\fR(1)" 4
+copies yaboot into the binary image.
 .IP "\fIlh_bootstrap\fR(1)" 4
 meta-helper for lh_bootstrap_*.
 .IP "\fIlh_bootstrap_cdebootstrap\fR(1)" 4




More information about the Debian-live-changes mailing list